#define AppExe "Threeter.exe"
#define AppName "Threeter"
#define AppVerName "Threeter 2.1.0"
#define AppVersion "2.1.0"
#define AppURL "http://threeter.devv.com/"
#define AppEmail "threeter@devv.com"
#define AppCompany "Devv"
#define AppCopyright "Copyright 2011, Devv.com"
#define SetupFile "ThreeterSetup"

[Setup]
AppID={{F991D457-169F-4447-8864-5B1E6F421C8F}
AppMutex={#AppName}
AppName={#AppName}
AppVerName={#AppVerName}
AppVersion={#AppVersion}
AppPublisherURL={#AppURL}
AppSupportURL={#AppURL}
AppUpdatesURL={#AppURL}
AppContact={#AppEmail}
VersionInfoProductName={#AppName}
VersionInfoProductVersion={#AppVersion}
DefaultDirName={pf}\Devv\{#AppName}
DefaultGroupName={#AppName}
OutputBaseFilename={#SetupFile}
AppPublisher={#AppCompany}
VersionInfoCompany={#AppCompany}
VersionInfoCopyright={#AppCopyright}
AllowNoIcons=true
Compression=lzma2/Max
SolidCompression=true
ShowLanguageDialog=no
RestartIfNeededByRun=false
AlwaysShowComponentsList=true
InternalCompressLevel=Ultra
PrivilegesRequired=none
MinVersion=0,5.1.2600
ExtraDiskSpaceRequired=2000
UninstallDisplayIcon={app}\Threeter.exe
DisableReadyPage=true
DisableFinishedPage=true
DisableDirPage=auto
DisableProgramGroupPage=yes
SetupIconFile=F:\Develop\Setup.ico
WizardImageFile=F:\Develop\Devv\Software\Threeter\Setup\ThreeterImgBig.bmp
WizardSmallImageFile=F:\Develop\Devv\Software\Threeter\Setup\ThreeterImgSmall.bmp
AppCopyright={#AppCopyright}
DisableWelcomePage=true

[Languages]
Name: en; MessagesFile: compiler:Default.isl
Name: de; MessagesFile: compiler:Languages\German.isl
Name: es; MessagesFile: compiler:Languages\Spanish.isl
Name: nl; MessagesFile: compiler:Languages\Dutch.isl
Name: pt; MessagesFile: compiler:Languages\BrazilianPortuguese.isl

[Components]
Name: Program; Description: Program files; Flags: fixed; Types: custom compact full
Name: Translations; Description: Translations; Types: full

[InstallDelete]
Name: {app}\de; Type: filesandordirs
Name: {app}\es; Type: filesandordirs
Name: {app}\nl; Type: filesandordirs
Name: {app}\pt; Type: filesandordirs
Name: {app}\*; Type: filesandordirs

[Dirs]
Name: {app}\de; Flags: uninsalwaysuninstall; Components: Translations
Name: {app}\es; Flags: uninsalwaysuninstall; Components: Translations
Name: {app}\nl; Flags: uninsalwaysuninstall; Components: Translations
Name: {app}\pt; Flags: uninsalwaysuninstall; Components: Translations

[Files]
Source: ..\Bin\Release\Threeter.exe; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Threeter.exe.config; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Devv.Core.Crypto.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Devv.Core.Erroo.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Devv.Core.Utils.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Hammock.ClientProfile.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Interop.SHDocVw.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\Newtonsoft.Json.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\TweetSharp.dll; DestDir: {app}; Flags: ignoreversion; Components: Program
Source: ..\Bin\Release\es\*; DestDir: {app}\es; Flags: ignoreversion recursesubdirs createallsubdirs; Components: Translations
Source: ..\Bin\Release\it\*; DestDir: {app}\es; Flags: ignoreversion recursesubdirs createallsubdirs; Components: Translations
Source: ..\Bin\Release\nl\*; DestDir: {app}\nl; Flags: ignoreversion recursesubdirs createallsubdirs; Components: Translations
Source: ..\Bin\Release\pt\*; DestDir: {app}\pt; Flags: ignoreversion recursesubdirs createallsubdirs; Components: Translations

[INI]
Filename: {app}\{#AppName}.url; Section: InternetShortcut; Key: URL; String: {#AppURL}

[Icons]
Name: {group}\{#AppName}; Filename: {app}\{#AppExe}
Name: {group}\{cm:ProgramOnTheWeb,{#AppName}}; Filename: {app}\{#AppName}.url
Name: {group}\{cm:UninstallProgram,{#AppName}}; Filename: {uninstallexe}

[Run]
Filename: {win}\Microsoft.NET\Framework\v4.0.30319\ngen.exe; Parameters: "install ""{app}\{#AppExe}"""; WorkingDir: {app}; StatusMsg: {cm:Ngen}; Flags: runhidden
Filename: {app}\{#AppExe}; Description: {cm:LaunchProgram,{#AppName}}; Flags: nowait postinstall skipifsilent

[UninstallRun]
Filename: {win}\Microsoft.NET\Framework\v4.0.30319\ngen.exe; Parameters: uninstall {#AppName}; WorkingDir: {app}; Flags: runhidden nowait; Languages: 

[UninstallDelete]
Type: files; Name: {app}

[CustomMessages]
en.SetupNeedsNETFramework40={#AppName} requires the .NET Framework 4.0. Please download and install the .NET Framework 4.0 and run this setup again.%n%nDo you want to download it now?
de.SetupNeedsNETFramework40={#AppName} bentigt das. NET Framework 4.0. Bitte laden und installieren. NET Framework 4.0 und fhren Sie Setup erneut aus. Wollen Sie sie jetzt herunterladen?
es.SetupNeedsNETFramework40={#AppName} requiere el .NET Framework 4.0. Por favor, descargar e instalar el .NET Framework 4.0 y ejecutar este programa de instalacin de nuevo.%n%nDesea descargarla ahora?
nl.SetupNeedsNETFramework40={#AppName} vereist het. NET Framework 4.0. Download en installeer het. NET Framework 4.0 en deze installatie opnieuw.%n%nWilt u deze nu downloaden?
pt.SetupNeedsNETFramework40=O {#AppName} requer a instalao do .NET Framework 4.0. Por favor, instale o .NET Framework 4.0 e execute este setup novamente.%n%nDeseja fazer o download do framework agora?
en.Ngen=Running optimizations, please wait...
de.Ngen=Running Optimierungen, bitte warten...
es.Ngen=Correr optimizaciones, por favor, espere...
nl.Ngen=Running optimalisaties, please wait...
pt.Ngen=Otimizando o programa, por favor aguarde...

[Code]
function InitializeSetup(): Boolean;
var
	ErrorCode: Integer;
	NetFrameWorkInstalled : Boolean;
	Result1 : Boolean;
begin
	NetFrameWorkInstalled := RegKeyExists(HKLM,'SOFTWARE\Microsoft\.NETFramework\v4.0.30319');
	if NetFrameWorkInstalled = true then
	begin
		Result := true;
	end;
	if NetFrameWorkInstalled = false then
	begin
		Result1 := MsgBox(ExpandConstant('{cm:SetupNeedsNETFramework40}'), mbConfirmation, MB_YESNO) = idYes;
			if Result1 = false then
			begin
				Result := false;
			end
			else
			begin
				Result := false;
				ShellExec('open','http://www.microsoft.com/downloads/en/details.aspx?FamilyID=0a391abd-25c1-4fc0-919f-b21f31ab88b7','','',SW_SHOWNORMAL,ewNoWait,ErrorCode);
			end;
	end;
end;
